/* An alternative solution of the task Triangulations
 * Author: Marek Cygan
 * Date: 29.05.2007
 */

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <list>
#include <queue>
#include <deque>
#include <cctype>
#include <string>
#include <vector>
#include <sstream>
#include <iterator>
#include <cmath>
using namespace std;

typedef vector <int > VI;
typedef vector < VI > VVI;
typedef long long LL;
typedef vector < LL > VLL;
typedef vector < double > VD;
typedef vector < string > VS;
typedef pair<int,int> PII;
typedef vector <PII> VPII;
typedef istringstream ISS;

#define ALL(x) x.begin(),x.end()
#define REP(i,n) for (int i=0; i<n; ++i)
#define FOR(var,pocz,koniec) for (int var=pocz; var<=koniec; ++var)
#define FORD(var,pocz,koniec) for (int var=pocz; var>=koniec; --var)
#define FOREACH(it, X) for(__typeof(X.begin()) it = X.begin(); it != X.end(); ++it)
#define PB push_back
#define PF push_front
#define MP(a,b) make_pair(a,b)
#define ST first
#define ND second
#define SIZE(x) (int)x.size()

int NWDR(int a, int b, LL &xp, LL &yp) {
    if (a==0) { xp=0; yp=1; return b; }
    LL x,y;
    int d = NWDR(b%a, a, x, y);
    yp = x;
    xp = y-(b/a)*x;
    return d;
}
int RevMod(int a, int p){
  LL x, y;
  NWDR(a, p, x, y);
  if (x < 0LL) return (p - ((-x) % (LL)p)) % p;
  return x % (LL)p;
}

const int K=40;
int potega[K];

//modulo p^k
int licz(int n,int p,int k,int mod){
  int acc=1,ile=0,wynik=0;
  potega[0]=1;
  FOR(i,1,K-1) potega[i]=p*potega[i-1];
  FOR(i,1,n){
    wynik=(wynik+(LL)acc*potega[min(ile,k)])%mod;
    int tab[]={2,2*i+1};
    REP(j,2){
      while (tab[j]%p==0) ile++,tab[j]/=p;
      acc=(LL)acc*tab[j]%mod;
    }
    int x=i+2;
    while (x%p==0) ile--,x/=p;
    acc=(LL)acc*RevMod(x,mod)%mod;
  }
  return wynik;
}

int main(){
  VPII v;
  int MOD,n;
  scanf("%d %d",&n,&MOD);
  n-=2;
  int oldmod=MOD,i=2;
  while (i*i<=MOD){
    int acc=1,ile=0;
    while (MOD%i==0) MOD/=i,acc*=i,ile++;
    if (ile) v.PB(MP(acc,licz(n,i,ile,acc)));
    i++;
  }
  if (MOD>1) v.PB(MP(MOD,licz(n,MOD,1,MOD)));
  int wynik=0;
  FOREACH(it,v) wynik=(wynik+(LL)oldmod/it->ST*RevMod(oldmod/it->ST,it->ST)%oldmod*it->ND)%oldmod;
  printf("%d\n",wynik);
  return 0;
}
